import React from "react";
import { BrowserRouter as Router, Route, Switch, Redirect } from "react-router-dom";
import createHistory from "history/createBrowserHistory";
import { connect } from "react-redux";
import { actionFullLogin } from "../actions/actionFullLogin";
import { actionFullRegister } from "../actions/actionFullRegister";
import { LoginForm } from "../pages/LoginForm";
import { FormReg } from "../pages/FormReg";
import { Main } from "../pages/Main";
import { Home } from "../pages/WorkPage";
import { Cabinet } from "../pages/Cabinet";
import ConnectFormSearch from "../pages/Search";

const ConnectLoginForm = connect(null, {onLogin:actionFullLogin}) (LoginForm);

const ConnectFormReg = connect(null, {FormReg:actionFullRegister}) (FormReg);

export let history = createHistory();

const Routs = ({token}) => {
    return (
        <div className="App">
          <Router history = {history}>
            {token && <Switch>
                <Redirect from="/login" to="/home" />
                <Route exact path='/home' component={Home} />
                <Route path='/cabinet' component={Cabinet}/>
                <Route path='/search' component={ConnectFormSearch}/>
            </Switch>}
            {!token && <Switch>
                <Route path='/login' component={ConnectLoginForm}/>
                <Route path='/reg' component={ConnectFormReg}/>
                <Route path='/' component={Main}/>
            </Switch>}
          </Router>
        </div>
    )
}

const ConnectedRouts = connect(state=>({token: state.a.token}), null)(Routs);

export default ConnectedRouts;