import { actionSearch } from "../actions/actionSearch";
import { connect } from "react-redux";
import { useState } from "react";

const Search = ({onSearch , snippets}) => {
    const [request, setRequest] = useState('');
  return (
    <>
    <div>
        <a href = '/home'>
            <button>
                Back to Work Page
            </button>
        </a>
    </div>
    <div>
        <input value={request} onChange={(e) => setRequest(e.target.value)}/>
        <button onClick = {() => onSearch(request)}>
            Search
        </button>
    </div>
    {snippets?.map((key, index) => (
        <div>
            <h3>
                {"Project Found"}
            </h3>
            <p>
                <span>Description: </span>
                {snippets?.[index]?.description}
            </p>
            <p>{`Owner: ${snippets?.[index]?.owner?.login}`}</p>
            <a href ={"/project/" + snippets?.[index]?._id}>
                <button>Open project</button>
            </a>
        </div>
    ))}
    </>
  )
};

const ConnectFormSearch = connect(state => ({snippets:state?.p?.searchSnippet?.payload?.data?.SnippetFind}) , {onSearch:actionSearch})(Search)

export default ConnectFormSearch;